com.impinj.octane

## Class Tag

- java.lang.Object
- - com.impinj.octane.Tag

-     public class Tag
      extends java.lang.Object

  A container class to hold information about a tag. Used by the tag report.
  See Also:
    `TagReport`, `TagReportData`

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `Tag()` construct a new tag object

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `short` | `getAntennaPortNumber()`
    `double` | `getChannelInMhz()`
    `short` | `getCrc()`
    `TagData` | `getEpc()` Contains the contents of the tag EPC memory backscatter by the tag.
    `ImpinjTimestamp` | `getFirstSeenTime()`
    `GpsCoordinates` | `getGpsCoodinates()`
    `ImpinjTimestamp` | `getLastSeenTime()`
    `TagModelDetails` | `getModelDetails()`
    `short` | `getPcBits()`
    `double` | `getPeakRssiInDbm()`
    `double` | `getPhaseAngleInRadians()`
    `java.util.List<TagReadOpResult>` | `getReadOperationResults()`
    `double` | `getRfDopplerFrequency()`
    `short` | `getTagSeenCount()`
    `TagData` | `getTid()`
    `TagData` | `getXpc()` Contains the contents of the tag XPC Words in the tag.
    `boolean` | `isAntennaPortNumberPresent()`
    `boolean` | `isChannelInMhzPresent()`
    `boolean` | `isCrcPresent()`
    `boolean` | `isFastIdPresent()`
    `boolean` | `isFirstSeenTimePresent()`
    `boolean` | `isGpsCoordinatesPresent()`
    `boolean` | `isLastSeenTimePresent()`
    `boolean` | `isPcBitsPresent()`
    `boolean` | `isPeakRssiInDbmPresent()`
    `boolean` | `isRfDopplerFrequencyPresent()`
    `boolean` | `isRfPhaseAnglePresent()`
    `boolean` | `isSeenCountPresent()`
    `boolean` | `isXpcWordsPresent()`
    `protected void` | `setAntennaPortNumber(short antennaPortNumber)`
    `protected void` | `setAntennaPortNumberPresent(boolean antennaPortNumberPresent)`
    `protected void` | `setChannelInMhz(double channelInMhz)`
    `protected void` | `setChannelInMhzPresent(boolean channelInMhzPresent)`
    `protected void` | `setCrc(short crc)`
    `protected void` | `setCrcPresent(boolean crcPresent)`
    `protected void` | `setEpc(TagData epc)`
    `protected void` | `setFastIdPresent(boolean fastIdPresent)`
    `protected void` | `setFirstSeenTime(ImpinjTimestamp firstSeenTime)`
    `protected void` | `setFirstSeenTimePresent(boolean firstSeenTimePresent)`
    `protected void` | `setGpsCoodinates(GpsCoordinates gpsCoodinates)`
    `protected void` | `setGpsCoordinatesPresent(boolean gpsCoordinatesPresent)`
    `protected void` | `setLastSeenTime(ImpinjTimestamp lastSeenTime)`
    `protected void` | `setLastSeenTimePresent(boolean lastSeenTimePresent)`
    `protected void` | `setModelDetails(TagModelDetails modelDetails)`
    `protected void` | `setPcBits(short pcBits)`
    `protected void` | `setPcBitsPresent(boolean pcBitsPresent)`
    `protected void` | `setPeakRssiInDbm(double peakRssiInDbm)`
    `protected void` | `setPeakRssiInDbmPresent(boolean peakRssiInDbmPresent)`
    `protected void` | `setPhaseAngleInRadians(double phaseAngleInRadians)`
    `protected void` | `setReadOperationResults(java.util.List<TagReadOpResult> readOperationResults)`
    `protected void` | `setRfDopplerFrequency(double rfDopplerFrequency)`
    `protected void` | `setRfDopplerFrequencyPresent(boolean rfDopplerFrequencyPresent)`
    `protected void` | `setRfPhaseAnglePresent(boolean rfPhaseAnglePresent)`
    `protected void` | `setSeenCountPresent(boolean seenCountPresent)`
    `protected void` | `setTagSeenCount(short tagSeenCount)`
    `protected void` | `setTid(TagData tid)`
    `protected void` | `setXpc(TagData xpc)`
    `protected void` | `setXpcWordsPresent(boolean xpcWordsPresent)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### Tag

          public Tag()

      construct a new tag object

  - ### Method Detail

    - #### getEpc

          public TagData getEpc()

      Contains the contents of the tag EPC memory backscatter by the tag. This does not contain the PC or CRC bits.
      Returns:
        the EPC as TagData

    - #### setEpc

          protected void setEpc(TagData epc)

    - #### getXpc

          public TagData getXpc()

      Contains the contents of the tag XPC Words in the tag. This can contain either XPC Word1 or both XPC Word1 and XPC Word2.
      Returns:
        the XPC as TagData

    - #### setXpc

          protected void setXpc(TagData xpc)

    - #### getAntennaPortNumber

          public short getAntennaPortNumber()

      Returns:
        The antenna port number on which the tag was observed. If the report has coalesced more than one read, this contains the most recent antenna on which the tag was seen.
      See Also:
        `ReportConfig.setIncludeAntennaPortNumber(java.lang.Boolean)`

    - #### setAntennaPortNumber

          protected void setAntennaPortNumber(short antennaPortNumber)

    - #### getChannelInMhz

          public double getChannelInMhz()

      Returns:
        The channel (RF frequency) on which the tag was observed. If the report has coalesced more than one read, this contains the most recent channel on which the tag was seen
      See Also:
        `ReportConfig.setIncludeChannel(java.lang.Boolean)`

    - #### setChannelInMhz

          protected void setChannelInMhz(double channelInMhz)

    - #### getFirstSeenTime

          public ImpinjTimestamp getFirstSeenTime()

      Returns:
        The first time that the tag was seen in this tag report. If the report contains multiple tag observations the first seen time is the earliest time of the observations coalesced to produce this report.
      See Also:
        `ReportConfig.setIncludeFirstSeenTime(java.lang.Boolean)`

    - #### setFirstSeenTime

          protected void setFirstSeenTime(ImpinjTimestamp firstSeenTime)

    - #### getLastSeenTime

          public ImpinjTimestamp getLastSeenTime()

      Returns:
        The last time that the tag was seen in this tag report. If the report contains multiple tag observations the last seen time is the latest time of the observations coalesced to produce this report.
      See Also:
        `ReportConfig.setIncludeLastSeenTime(java.lang.Boolean)`

    - #### setLastSeenTime

          protected void setLastSeenTime(ImpinjTimestamp lastSeenTime)

    - #### getPeakRssiInDbm

          public double getPeakRssiInDbm()

      Returns:
        The largest rssi (receive signal strength indicator) for the observations coalesced in this tag report.
      See Also:
        `ReportConfig.setIncludePeakRssi(java.lang.Boolean)`

    - #### setPeakRssiInDbm

          protected void setPeakRssiInDbm(double peakRssiInDbm)

    - #### getTagSeenCount

          public short getTagSeenCount()

      Returns:
        the number of tag observations that were coalesced into this tag report
      See Also:
        `ReportConfig.setIncludeSeenCount(java.lang.Boolean)`

    - #### setTagSeenCount

          protected void setTagSeenCount(short tagSeenCount)

    - #### getTid

          public TagData getTid()

      Returns:
        the TID (tag Identifier) of the tag
      See Also:
        `ReportConfig.setIncludeFastId(java.lang.Boolean)`

    - #### setTid

          protected void setTid(TagData tid)

    - #### getRfDopplerFrequency

          public double getRfDopplerFrequency()

      Returns:
        the most recent Doppler frequency measured by the reader on this tag. If multiple tag observations are coalesced into this report the most recent Doppler frequency is reported
      See Also:
        `ReportConfig.setIncludeDopplerFrequency(java.lang.Boolean)`

    - #### setRfDopplerFrequency

          protected void setRfDopplerFrequency(double rfDopplerFrequency)

    - #### getPhaseAngleInRadians

          public double getPhaseAngleInRadians()

      Returns:
        the most recent phase angle measured by the reader on this tag. If multiple tag observations are coalesced into this report the most recent phase angle is reported
      See Also:
        `ReportConfig.includePhaseAngle`

    - #### setPhaseAngleInRadians

          protected void setPhaseAngleInRadians(double phaseAngleInRadians)

    - #### getCrc

          public short getCrc()

      Returns:
        the CRC of the EPC memory bank backscattered during the tag observation.
      See Also:
        `ReportConfig.includeCrc`

    - #### setCrc

          protected void setCrc(short crc)

    - #### getPcBits

          public short getPcBits()

      Returns:
        the Protocol Control Bits (PC bits) of backscattered with the tags EPC
      See Also:
        `ReportConfig.includePcBits`, `PcBits`

    - #### setPcBits

          protected void setPcBits(short pcBits)

    - #### getGpsCoodinates

          public GpsCoordinates getGpsCoodinates()

      Returns:
        the GPS coordinates associated with the reader at the time of the tag read (not supported by all readers).If multiple tag observations are coalesced into this report the most recent GPS coordinate is reported
      See Also:
        `ReportConfig.includeGpsCoordinates`

    - #### setGpsCoodinates

          protected void setGpsCoodinates(GpsCoordinates gpsCoodinates)

    - #### getModelDetails

          public TagModelDetails getModelDetails()

      Returns:
        details on the tag model such as name, EPC memory size and user memory size. This feature is only available with Impinj Monza 4 and newer tags.
      See Also:
        `ReportConfig.includeFastId`

    - #### setModelDetails

          protected void setModelDetails(TagModelDetails modelDetails)

    - #### getReadOperationResults

          public java.util.List<TagReadOpResult> getReadOperationResults()

      Returns:
        a list of read results for the optimized reads configured for this reader.
      See Also:
        `ReportConfig.optimizedReadOps`

    - #### setReadOperationResults

          protected void setReadOperationResults(java.util.List<TagReadOpResult> readOperationResults)

    - #### isAntennaPortNumberPresent

          public boolean isAntennaPortNumberPresent()

      Returns:
        true if the report contains a valid antenna port number

    - #### setAntennaPortNumberPresent

          protected void setAntennaPortNumberPresent(boolean antennaPortNumberPresent)

    - #### isChannelInMhzPresent

          public boolean isChannelInMhzPresent()

      Returns:
        true if the report contains a channel value

    - #### setChannelInMhzPresent

          protected void setChannelInMhzPresent(boolean channelInMhzPresent)

    - #### isFirstSeenTimePresent

          public boolean isFirstSeenTimePresent()

      Returns:
        true if the report contains a first seen timestamp

    - #### setFirstSeenTimePresent

          protected void setFirstSeenTimePresent(boolean firstSeenTimePresent)

    - #### isLastSeenTimePresent

          public boolean isLastSeenTimePresent()

      Returns:
        true if the report contains a last seen timestamp

    - #### setLastSeenTimePresent

          protected void setLastSeenTimePresent(boolean lastSeenTimePresent)

    - #### isPeakRssiInDbmPresent

          public boolean isPeakRssiInDbmPresent()

      Returns:
        true if the report contains a peak rssi value

    - #### setPeakRssiInDbmPresent

          protected void setPeakRssiInDbmPresent(boolean peakRssiInDbmPresent)

    - #### isFastIdPresent

          public boolean isFastIdPresent()

      Returns:
        true if the report contains the TID results in
      See Also:
        `getTid()`, `getModelDetails()`

    - #### setFastIdPresent

          protected void setFastIdPresent(boolean fastIdPresent)

    - #### isRfPhaseAnglePresent

          public boolean isRfPhaseAnglePresent()

      Returns:
        true if the Rf phase angle is present in the report

    - #### setRfPhaseAnglePresent

          protected void setRfPhaseAnglePresent(boolean rfPhaseAnglePresent)

    - #### isSeenCountPresent

          public boolean isSeenCountPresent()

      Returns:
        true if the seen count is present in the report

    - #### setSeenCountPresent

          protected void setSeenCountPresent(boolean seenCountPresent)

    - #### isCrcPresent

          public boolean isCrcPresent()

      Returns:
        true if the CRC is present in the report

    - #### setCrcPresent

          protected void setCrcPresent(boolean crcPresent)

    - #### isPcBitsPresent

          public boolean isPcBitsPresent()

      Returns:
        true if the PC bits are present in the report

    - #### setPcBitsPresent

          protected void setPcBitsPresent(boolean pcBitsPresent)

    - #### isRfDopplerFrequencyPresent

          public boolean isRfDopplerFrequencyPresent()

      Returns:
        true if the Rf Doppler frequency is present in the report

    - #### setRfDopplerFrequencyPresent

          protected void setRfDopplerFrequencyPresent(boolean rfDopplerFrequencyPresent)

    - #### isGpsCoordinatesPresent

          public boolean isGpsCoordinatesPresent()

      Returns:
        true if the GPS coordinates are present in the report

    - #### setGpsCoordinatesPresent

          protected void setGpsCoordinatesPresent(boolean gpsCoordinatesPresent)

    - #### isXpcWordsPresent

          public boolean isXpcWordsPresent()

      Returns:
        true if the XPC Words are present in the report

    - #### setXpcWordsPresent

          protected void setXpcWordsPresent(boolean xpcWordsPresent)